/// api_version=2
var script = registerScript({
    name: "RazerKeyboard",
    version: "2.0.0",
    authors: ["CCBlueX"]
});

script.import("keyboard_files/classloader.js");

var cl = new ClassLoader(mc.mcDataDir + "/LiquidBounce-1.8/scripts/keyboard_files/jchroma-0.1.jar");

var Integer = Java.type("java.lang.Integer");
var Timer = Java.type("java.util.Timer");
var Keyboard = Java.type("org.lwjgl.input.Keyboard");
var Integer = Java.type("java.lang.Integer");

var JChroma = cl.type("org.jglr.jchroma.JChroma");
var CustomKeyboardEffect = cl.type("org.jglr.jchroma.effects.CustomKeyboardEffect");
var ColorRef = cl.type("org.jglr.jchroma.utils.ColorRef");
var KeyboardKeys = cl.type("org.jglr.jchroma.utils.KeyboardKeys");

function translateKeyCode(keyCode) {
    var lwjglKeyboardFields = Keyboard.class.getDeclaredFields();

    for (var i = 0; i < lwjglKeyboardFields.length; i++) {
        var lwjglKeyboardField = lwjglKeyboardFields[i];

        if (!lwjglKeyboardField.isAccessible())
            lwjglKeyboardField.setAccessible(true);

        try {
            if (!lwjglKeyboardField.getGenericType().getTypeName().equals("int"))
                return;

            var lwjglKey = lwjglKeyboardField.getInt(null);

            if (lwjglKey == keyCode) {
                var keyName = lwjglKeyboardField.getName().substring(4);

                var razerKeyboardFields = KeyboardKeys.class.getDeclaredFields();

                for (var i = 0; i < razerKeyboardFields.length; i++) {
                    var razerKeyboardField = razerKeyboardFields[i];

                    if (!razerKeyboardField.isAccessible())
                        razerKeyboardField.setAccessible(true);

                    try {
                        var razerKeyName = razerKeyboardField.getName().substring(6);

                        if (razerKeyName.equalsIgnoreCase(keyName))
                            return razerKeyboardField.getInt(null);
                    } catch (e) {
                        e.printStackTrace();
                        return Integer.MIN_VALUE;
                    }
                }

                return Integer.MIN_VALUE;
            }
        } catch (e) {
            e.printStackTrace();
            return Integer.MIN_VALUE;
        }
    }

    return Integer.MIN_VALUE;
}

script.registerModule({
    name: "RazerKeyboard",
    category: "Misc",
    description: "Enables custom colored keys on Razer keyboards.",
    settings: {
        keys: Setting.boolean({
            name: "Keys",
            default: true
        }),
        health: Setting.boolean({
            name: "Health",
            default: false
        }),
        updateDelay: Setting.integer({
            name: "UpdateDelay",
            min: 1,
            max: 1000,
            default: 50
        })
    }
}, function(module) {

    var timer = null;

    var updateKeyboard = function() {
        if (mc.thePlayer !== null && mc.theWorld !== null) {
            var customKeyboardEffect = new CustomKeyboardEffect();

            if (module.settings.health.get()) {
                var health = mc.thePlayer.getHealth() / mc.thePlayer.getMaxHealth();
                customKeyboardEffect.fill(new ColorRef(~~(255 - (health * 255)), ~~(health * 255), 0));
            }

            if (module.settings.keys.get()) {
                moduleManager.getModules().forEach(function (moduleC) {
                    if (moduleC.getKeyBind() == Keyboard.KEY_NONE)
                        return;

                    var keyCode = translateKeyCode(moduleC.getKeyBind());

                    if (keyCode == Integer.MIN_VALUE)
                        return;

                    customKeyboardEffect.setKeyColor(keyCode, moduleC.getState() ? new ColorRef(66, 244, 98) : new ColorRef(255, 66, 66));
                });
            }

            JChroma.getInstance().createKeyboardEffect(customKeyboardEffect);
        } else {
            JChroma.getInstance().free()
        }
    }

    module.on("enable", function() {
        timer = new Timer("updateKeys", true);

        JChroma.getInstance().init();

        timer.schedule(function () {
            updateKeyboard();
        }, module.settings.updateDelay.get(), module.settings.updateDelay.get());
    });

    module.on("disable", function() {
        if (timer !== null) {
            timer.cancel();
        }
        JChroma.getInstance().free();
    });
});